###############################################################
# 실습 5번 예제 1
# 값이 누락되어 있는 경우 제거 후 분석
###############################################################

df <- data.frame(sex = c("M", "F", NA, "M", "F"), score = c(5, 4, 3, 4, NA))
df
is.na(df)          # 결측치 확인
table(is.na(df))    # table 명령어를 이용하여 결측치 빈도 출력


###############################################################
# 실습 5번 예제 2
###############################################################

table(is.na(df$sex))    # sex 결측치 빈도 출력
table(is.na(df$score))  # score 결측치 빈도 출력

###############################################################
# 실습 5번 예제 3 (NA가 있는 경우 결과는 NA로 나옴에 주의)
###############################################################

mean(df$score)  # 평균 산출
sum(df$score)   # 합계 산출

###############################################################
# 실습 5번 예제 4 (결측치 있는 행 제거하기)
###############################################################

library(dplyr) # dplyr 패키지 로드
df %>% filter(is.na(score))   # score가 NA인 데이터만 출력
df %>% filter(!is.na(score))  # score가 NA가 아닌 데이터만 출력 

###############################################################
# 실습 5번 예제 5 (결측치 제외한 데이타로 분석하기) 
###############################################################

df_nomiss <- df %>% filter(!is.na(score))  # score 결측치 제거
mean(df_nomiss$score)                      # score 평균 산출
sum(df_nomiss$score)                       # score 합계 산출


###############################################################
# 실습 5번 예제 6 (여러 변수 동시에 결측치 없는 데이타 추출하기
###############################################################

# score, sex 결측치 제외
df_nomiss <- df %>% filter(!is.na(score) & !is.na(sex))
df_nomiss

###############################################################
# 실습 5번 예제 7 (결측치가 하나라도 있으면 무조건 제거하기)
# 분석에 필요한 데이터 손실 가능성 높음
###############################################################

df_nomiss2 <- na.omit(df)  # 모든 변수에 결측치 없는 데이터 추출
df_nomiss2

###############################################################
# 실습 5번 예제 8 (함수의 결측치 제외 기능 이용하기)
###############################################################

mean(df$score, na.rm = T)  # 결측치 제외하고 평균 산출
sum(df$score, na.rm = T)   # 결측치 제외하고 합계 산출

###############################################################
# 실습 5번 예제 9 (summarise 함수에서 결측치 제외 기능 이용하기)
###############################################################

exam <- read.csv("csv_exam.csv")    # 데이터 불러오기
exam
exam[c(3, 8, 15), "math"] <- NA      # 3, 8, 15행의 math에 NA 할당
exam

install.packages("dplyr")
library(dplyr) # dplyr 패키지 로드

exam %>% summarise(mean_math = mean(math))      # 평균 산출 안됨
exam %>% summarise(mean_math = mean(math, na.rm = T))  #평균 산출 됨 


###############################################################
# 실습 5번 예제 10 (결측치 대체하기)
# 결측치가 많을 경우 모두 제외하면 데이타 손실이 큼
# 결측치를 제외하기 위해서는 대표값(평균, 중간값, 최빈값)등을 사용
###############################################################

mean(exam$math, na.rm = T)    # 결측치 제외하고 math 평균 산출
exam$math <- ifelse(is.na(exam$math), 55, exam$math) # math가 NA면 55로 대체
table(is.na(exam$math))                                # 결측치 빈도표 생성 
exam 
mean(exam$math)  # math 평균 산출




